#import <stdio.h>
#import <stdlib.h>
#import <string.h>
#import <fcntl.h>
#import <sys/stat.h>
#import <sys/types.h>
#import <inttypes.h>
#import <unistd.h>
#define __STDC_FORMAT_MACROS

#import <time.h>
#import <math.h>
#import <mach/mach.h>
#import <Cocoa/Cocoa.h>
#import <CoreFoundation/CFNumber.h>
#import <IOKit/IOKitLib.h>
#import <IOKit/IOCFPlugIn.h>
#import <IOKit/usb/IOUSBLib.h>

#import "b25/arib_std_b25.h"
#import "b25/b_cas_card.h"


@interface Friio : NSObject {
	mach_port_t				masterPort;
    io_service_t			usbDeviceRef;
	io_service_t			usbInterfaceRef;
	IOUSBDeviceInterface	**dev;
	IOUSBInterfaceInterface	**interface;
	const char				*file_path;
	int						friio_type;
	int						find_type;
}

// レスポンス構造体
typedef struct{
	IOUSBInterfaceInterface	**interface;
	UInt8					buffer[327680];
	FILE					*fd;
} USBResponse;

// 資料不足のため未実装
struct Black_Channel_Sequence {
	uint8_t byReqNo;
	uint16_t wValue;
	uint16_t wIndex;
	uint8_t bData;		// 3byteのデータ部があるか
	uint8_t byData1;	// データ１
	uint8_t byData2;	// データ２
	uint8_t byData3;	// データ３
};

typedef enum {
	FRIIO_ANY,
	FRIIO_WHITE,
	FRIIO_BLACK,
	FRIIO_TYPES_LEN,
} FriioType;
	
// インスタンスメソッド
- (int)open:(int)type;
- (int)_findDeviceInterface;
- (int)_setupInterface;
- (int)close;

- (int)_sendRequest:(UInt16)wValue withIndex:(UInt16)wIndex;
- (int)initStageA;
- (int)initStageB;
- (int)initStream;

- (int)rec:(const char*)file withTime:(int)rec_sec;
- (void)_recWorker:(id)obj;

- (int)setChannel:(int)channel;
- (int)setChannel_Black:(int)channel Space:(uint32_t)dwSpace;
- (float)getSignalLevel;
- (void)setLED:(int)color;

// コールバック関数
void _workerCallback(USBResponse *readRes, IOReturn result, void *arg);

@end
